#!/usr/bin/env python

from __future__ import with_statement

import cgi
import codecs
import os
import random

import cgitb
cgitb.enable()

HTML_SINGLE = """\
<a href="%(url)s">
  <img alt="%(alt)s" style="border-width:0"
    src="/%(logo)s" />
</a>
"""

HTML_ALL = """\
<br />
%(alt)s
<br />
<a href="%(url)s">
  <img style="border-width:0"
    src="/%(logo_c)s" />
</a>
<br />
<a href="%(url)s">
  <img style="border-width:0"
    src="/%(logo_r)s" />
</a>
<br />
"""

print "Content-Type: text/html"     # HTML is following
print                               # blank line, end of headers


def get_winner_data(fname):
    """Return random banner and related info."""
    content = [x for x in os.listdir('../prop') if x[0] != '.']
    chosen = random.choice(content)

    logo = os.path.join('prop', chosen, fname)

    fname = os.path.join('../prop', chosen, 'url.txt')
    with codecs.open(fname, 'r', 'utf8') as fh:
        info = fh.readlines()

    alt, url = [x.strip() for x in info]
    return url.encode('latin1'), logo, alt.encode('latin1')


def get_all():
    """Return all info for all banners."""
    content = [x for x in os.listdir('../prop') if x[0] != '.']

    for chosen in content:
        logo_c = os.path.join('prop', chosen, 'logo_c.png')
        logo_r = os.path.join('prop', chosen, 'logo_r.png')

        fname = os.path.join('../prop', chosen, 'url.txt')
        with codecs.open(fname, 'r', 'utf8') as fh:
            info = fh.readlines()

        alt, url = [x.strip() for x in info]
        yield url.encode('latin1'), logo_c, logo_r, alt.encode('latin1')


def main(factor):
    """Main."""
    if factor not in ('c', 'r', 't'):
        return

    if factor == 't':
        for url, logo_c, logo_r, alt in get_all():
            print HTML_ALL % dict(url=url, logo_r=logo_r,
                                  logo_c=logo_c, alt=alt)
        return

    fname = 'logo_%s.png' % (factor,)
    url, logo, alt = get_winner_data(fname)
    result = HTML_SINGLE % dict(url=url, logo=logo, alt=alt)
    print result


form = cgi.FieldStorage()
opc = form.getfirst('f')
main(opc)
